const Mesa = require('vendor/Mesa.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {

  /**
   * Mesa Script
   *
   * @param {object} payload The payload data
   * @param {object} context Additional context about this task
   */
  script = (payload, context) => {
    const vars = context.steps;

    let chunk = "";
    let parts = [];
    let partIndex = 0;
    let totalLength = 0;      

    for (let i = 1; i <= vars.data.length; i++) {
      let row = vars.data[i - 1];
      chunk = chunk + "\n\n" + i + ". " + row.body; 

      if (chunk.length > 2000) {
        parts[partIndex] = chunk;
        chunk = "";
        partIndex++;
      }

      totalLength += row.body.length;
      if (totalLength > 25000) {
        break;
      }
    }

    // Grab that last chunk
    parts[partIndex] = chunk;    

    let newPayload = {
      "parts": parts,
    }


    Mesa.trigger.setTaskExternalData({
      label: "Broke into " + parts.length + " chunks - total length: " + totalLength,
    });  

    // We're done, call the next step!
    Mesa.output.next(newPayload);
  }
}
